
; CC5X Version 3.2K, Copyright (c) B Knudsen Data
; C compiler for the PICmicro family
; ************  13. Mar 2007  13:41  *************

	processor  16F628
	radix  DEC

	__config 0x3F18

TMR0        EQU   0x01
PORTA       EQU   0x05
TRISA       EQU   0x85
PORTB       EQU   0x06
TRISB       EQU   0x86
INTCON      EQU   0x0B
Carry       EQU   0
Zero_       EQU   2
RP0         EQU   5
RP1         EQU   6
OPTION_REG  EQU   0x81
T1CON       EQU   0x10
CMCON       EQU   0x1F
RA4         EQU   4
RA5         EQU   5
RA7         EQU   7
Dip_new     EQU   0x27
Dip_old     EQU   0x29
ms          EQU   0x25
bitcount    EQU   0x24
ticks       EQU   0x20
helper      EQU   0x22

	GOTO main

  ; FILE c:\projekte\picsel\lugs\synth.c
			;/* Synth - Erzeugen von Signalen fuer AEB750 Autogas-Umschalter     */
			;/*                                                                  */
			;/* (c) C.Schirp  released for non-commercial use                    */
			;/*                                                                  */
			;/* V1.0 Erstausgabe                                                 */
			;/*                                                                  */
			;/*                                                                  */
			;
			;
			;#include <c:\projekte\picsel\cc5\16F628.h>
			;#include <c:\projekte\picsel\cc5\int16CXX.h>
			;#include <c:\projekte\picsel\cc5\inline.h>
			;
			;#pragma config =0x3F18 
			;
			;// Standard ohne ext reset 0x3F18
			;// Standard mit ext Reset  0x3F38  
			;
			;/* Port- Defines */
			;
			;#define TX_PIN	RA7
			;#define LED_R   RA6
			;#define LED_G   RA4
			;#define BIT_13	RA5
			;
			;/* variablen */
			;bank0 uns16 Dip_new;	// alte Schalterstellung
			;bank0 uns16 Dip_old;	// neue Schalterstellung
			;
			;
			;/* defines fuer die SW */
			;
			;#define TICKTIME 666
			;
			;/*------------------------------------------------------------------*/
			;/*   II  N   N  II TTTTT                                            */
			;/*   II  NN  N  II   T                                              */
			;/*   II  N N N  II   T                                              */
			;/*   II  N  NN  II   T                                              */
			;/*   II  N   N  II   T                                              */
			;/*------------------------------------------------------------------*/
			;
			;void init (void)
			;{
init
			;	/* PORT A, B Config */
			;	CMCON = 0x07;		// kein Komparator
	MOVLW .7
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF CMCON
			;	
			;	TRISA = 0b0010.1111; 	// 4,7,6 Ausgnge,LO Eingaenge 	
	MOVLW .47
	BSF   0x03,RP0
	MOVWF TRISA
			;	TRISB = 0b1111.1111;	// alles Eingaenge
	MOVLW .255
	MOVWF TRISB
			;	
			;	PORTA = 0b1101.0000;	// HINT: erst Direction, dann Wert!
	MOVLW .208
	BCF   0x03,RP0
	MOVWF PORTA
			;	PORTB = 0x00;	
	CLRF  PORTB
			;
			;	/*sonstiges*/
			;	T1CON = 0x00;		// Timer disabled
	CLRF  T1CON
			;	OPTION_REG = 0x04;	/* pull-up portB, falling edge int, no WDT prescaler, prescale=32 */
	MOVLW .4
	BSF   0x03,RP0
	MOVWF OPTION_REG
			;	INTCON = 0; 		// reset and disable all interrupts by default
	CLRF  INTCON
			;
			;	/* Variablen initialisieren */
			;	Dip_old=0;
	BCF   0x03,RP0
	CLRF  Dip_old
	CLRF  Dip_old+1
			;}
	RETURN
			;
			;void Lese_Dipswitch(void)
			;{
Lese_Dipswitch
			;#pragma updateBank 0 /* OFF, all cores */
			;
			;	Dip_new.low8 = PORTB;	// Bits 0..7
	MOVF  PORTB,W
	MOVWF Dip_new
			;	Dip_new.high8 = PORTA;
	MOVF  PORTA,W
	MOVWF Dip_new+1
			;	Dip_new.high8 &= 0x0F;	// Bits 8..11
	MOVLW .15
	ANDWF Dip_new+1,1
			;	Dip_new.12 = BIT_13;		// Bit 12
	BCF   Dip_new+1,4
	BTFSC 0x05,RA5
	BSF   Dip_new+1,4
			;	Dip_new.13 = 1;				// Bit 13 (startbit) immer an
	BSF   Dip_new+1,5
			;	
			;#pragma updateBank 1 /* ON,  all cores */
			;}
	RETURN
			;
			;void Delay1ms(uns16 ms)
			;{
Delay1ms
			;	while(ms)			// Schleife verlassen wenn ms=0 ist
m001	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  ms,W
	IORWF ms+1,W
	BTFSC 0x03,Zero_
	GOTO  m004
			;	{
			;	    OPTION = 2; 		// Vorteiler auf 8 einstellen
	MOVLW .2
	BSF   0x03,RP0
	MOVWF OPTION_REG
			;	    TMR0 = 131; 		// 125 * 8 = 1000 (= 1 ms)
	MOVLW .131
	BCF   0x03,RP0
	MOVWF TMR0
			;	    while (TMR0);		// abwarten einer Milisekunde
m002	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  TMR0,W
	BTFSC 0x03,Zero_
	GOTO  m003
	GOTO  m002
			;	    ms--;			// "ms" mit jeder Milisekunde ernidrigen
m003	BCF   0x03,RP0
	BCF   0x03,RP1
	DECF  ms,1
	INCF  ms,W
	BTFSC 0x03,Zero_
	DECF  ms+1,1
			;	}
	GOTO  m001
			;}
m004	RETURN
			;
			;void Send_Msg(void)
			;{
Send_Msg
			;#pragma updateBank 0 /* OFF, all cores */
			;
			;	uns8 bitcount;
			;	
			;	LED_G = 0;	// Send Msg
	BCF   0x05,RA4
			;	
			;	TX_PIN = 0;	// Start 3ms Low
	BCF   0x05,RA7
			;	Delay1ms(3);
	MOVLW .3
	MOVWF ms
	CLRF  ms+1
	CALL  Delay1ms
			;	
			;	for (bitcount=0; bitcount<14; bitcount++)
	CLRF  bitcount
m005	MOVLW .14
	SUBWF bitcount,W
	BTFSC 0x03,Carry
	GOTO  m008
			;	{
			;		TX_PIN = 1;
	BSF   0x05,RA7
			;		
			;		if (Dip_new & 0x2000)
	BTFSS Dip_new+1,5
	GOTO  m006
			;		{
			;			Delay1ms(4);	// Eins = 4ms high
	MOVLW .4
	MOVWF ms
	CLRF  ms+1
	CALL  Delay1ms
			;		}
			;		else
	GOTO  m007
			;		{
			;			Delay1ms(2);	// Null = 2ms high
m006	MOVLW .2
	MOVWF ms
	CLRF  ms+1
	CALL  Delay1ms
			;		}
			;		
			;		Dip_new <<=1;
m007	BCF   0x03,Carry
	RLF   Dip_new,1
	RLF   Dip_new+1,1
			;		
			;		TX_PIN = 0;
	BCF   0x05,RA7
			;		Delay1ms(3);
	MOVLW .3
	MOVWF ms
	CLRF  ms+1
	CALL  Delay1ms
			;	}
	INCF  bitcount,1
	GOTO  m005
			;	
			;	TX_PIN = 1;	// Idle-Pegel
m008	BSF   0x05,RA7
			;	
			;	LED_G = 1;	// Send Msg
	BSF   0x05,RA4
			;
			;#pragma updateBank 1 /* ON,  all cores */	
			;}
	RETURN
			;
			;
			;
			;/*------------------------------------------------------------------*/
			;/*     M     M    A    II  N   N                                    */
			;/*     MM   MM   A A   II  NN  N                                    */
			;/*     M M M M  A   A  II  N N N                                    */
			;/*     M  M  M  AAAAA  II  N  NN                                    */
			;/*     M     M  A   A  II  N   N                                    */
			;/*------------------------------------------------------------------*/
			;
			;void main (void)
			;{
main
			;	uns16 ticks;
			;	uns16 helper;
			;	init();
	CALL  init
			;	
			;	ticks = 0; // Einmal sofort nach dem Start senden
	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  ticks
	CLRF  ticks+1
			;	
			;	Delay1ms(200);	// Erstmal initialisieren lassen
	MOVLW .200
	MOVWF ms
	CLRF  ms+1
	CALL  Delay1ms
			;
			;#pragma updateBank 0 /* OFF, all cores */
			;  
			;	while (1)
			;	{
			;		LED_R ^=1;	// Togle lifeindicator
m009	MOVLW .64
	XORWF PORTA,1
			;		
			;		Lese_Dipswitch();
	CALL  Lese_Dipswitch
			;		
			;		// Neue Schalterstellung oder 6 sek abgelaufen
			;		helper = Dip_new-Dip_old;
	MOVF  Dip_old+1,W
	SUBWF Dip_new+1,W
	MOVWF helper+1
	MOVF  Dip_old,W
	SUBWF Dip_new,W
	MOVWF helper
	BTFSS 0x03,Carry
	DECF  helper+1,1
			;		
			;		Dip_old = Dip_new;	// alte Schalterstellung merken
	MOVF  Dip_new,W
	MOVWF Dip_old
	MOVF  Dip_new+1,W
	MOVWF Dip_old+1
			;		
			;		if (helper || (!ticks))
	MOVF  helper,W
	IORWF helper+1,W
	BTFSS 0x03,Zero_
	GOTO  m010
	MOVF  ticks,W
	IORWF ticks+1,W
	BTFSS 0x03,Zero_
	GOTO  m011
			;		{
			;			Send_Msg();
m010	CALL  Send_Msg
			;			ticks = TICKTIME;	// 6 sekunden
	MOVLW .154
	MOVWF ticks
	MOVLW .2
	MOVWF ticks+1
			;		}
			;		
			;		Delay1ms(9);	// Abstand zwei Botschaften
m011	MOVLW .9
	MOVWF ms
	CLRF  ms+1
	CALL  Delay1ms
			;		
			;		ticks--;	// Ticktimer zaehlen
	DECF  ticks,1
	INCF  ticks,W
	BTFSC 0x03,Zero_
	DECF  ticks+1,1
			;	}; 
	GOTO  m009
			;#pragma updateBank 1 /* ON, all cores */
m012	SLEEP
	GOTO main

	END


; *** KEY INFO ***

; 0x0001   22 word(s)  1 % : init
; 0x0017   11 word(s)  0 % : Lese_Dipswitch
; 0x0022   26 word(s)  1 % : Delay1ms
; 0x003C   36 word(s)  1 % : Send_Msg
; 0x0060   48 word(s)  2 % : main

; RAM usage: 11 bytes (7 local), 213 bytes free
; Maximum call level: 2
; Total of 144 code words (7 %)
